﻿#!/usr/bin/perl -w
use strict;
use warnings;
use utf8;
use open qw(:std :utf8);
use integer;


# Filter_4_01_pb.pl
# 2010-08-16
# Wolfgang Schmidle

my $finalformat = "TEI";

# text input

my @text;
while(<>) { push @text, $_; }


# go through the text

my $n = 0;
my $nAlsText;

foreach (@text) {

	next unless /<pb/;

	# add attributes "n" and "file" in <pb>

	$n++;
	$nAlsText = "$n";
	if ($n < 1000) { $nAlsText = "0$nAlsText"; }
	if ($n < 100) { $nAlsText = "0$nAlsText"; }
	if ($n < 10) { $nAlsText = "0$nAlsText"; }
	
	if (m!>\[.+?file=([^ \]]+)!) { $nAlsText = $1; }
	my $onorm = "";
	if (m!>\[o-norm=([^ \]]+)!) { $onorm = ' o-norm="'.$1.'"'; }
	s!>\[.+?\]!>!;
	
	s! n="\d+"!!;
	s! file="\d+"!!;
	
	s!<pb ([^>]+)/>!<pb $1${onorm} file="$nAlsText" n="$n"/>!g;
	s!<pb/>!<pb ${onorm}file="$nAlsText" n="$n"/>!g;

	
	# running heads 
	
	if ($finalformat eq "TEI") {
		# leave <rh> as separate XML element
	
		s!<rh([ >])!<rhead$1!;
		s!</rh>!</rhead>!;	
	
	} else {
		# turn <rh> into an attribute of <pb> and remove styles in <rh>
	
		if (s!(<pb [^>]+)/><rh[^>]*>(.+)</rh>!$1 rhead=""/>!) {
			my $rhead = $2;
			$rhead =~ s!<[^>]+>!!g;
			s! rhead=""! rhead="$rhead"!;	
		}
	}
}


# geänderten Text ausgeben

print @text;

# TO DO:
# wenn die <pb> neu numeriert werden, nachdem die Floats herausgezogen wurden:
# sollen dann die link-Namen der Figures etc. angepasst werden?
# Eventuell ist es einfacher, den raw text zu korrigieren und von vorne anzufangen?
