﻿#!/usr/bin/perl -w
use strict;
use warnings;
use utf8;
use open qw(:std :utf8);
use integer;


# Filter_4_04_insert_s.pl
# version 2010-08-15
# Wolfgang Schmidle

# das ist die Version des Skriptes speziell für Chinesisch!

my $language = "zh";


my $indent = "  ";
my $satzzeichen = "[！？。，、：；]";


# text input

my @text;
while(<>) { push @text, $_; }


# go through the text

my $inP = 0;

foreach (@text) {

	if (/<p[ >]/) { $inP = 1; }
	next unless $inP;
	
	if (m!<s>!) { die "4.04: Es gibt bereits <s> im Text: $_\n"; }


	# -  main
	s!<p>!<p>\n<s>!;
	s!(<p [^>]+>)!$1\n<s>!;
	s!</p>!</s></p>!;
	
	s!($satzzeichen)!$1</s><s>!g;

	# -  corrections
	s!</s><s>）!）</s><s>!g; # move closing parenthesis into the previous sentence
	s!</s><s><lb/>!<lb/></s><s>!g;
	s!</s><s><smlb/>!<smlb/></s><s>!g;
	
	# -  final corrections
	s!<s></p>!</p>!;
	s!<s></s></p>!</p>!;  # diese Zeile fehlt auch im normalen s-Skript!

	s!</s>!</s>\n!g;
	s!<s>!$indent<s>!g;
	
	if (m!</p>!) { $inP = 0; }
}


# geänderten Text ausgeben

print @text;


# TO DO:
# nach welchem Kriterium werden in notes <s> eingefügt oder nicht?
# Vorschlag: einzeilige note, oder wenn das Ergebnis ein einziger <s> wäre: kein <s>
# da kann man sich aber doch fragen, warum ist das in <p> anders, der bekommt immer <s>,
# auch wenn es nur ein einziges ist. Also vielleicht:
# einzeilige Marginalie: kein <s>. Wäre geradliniger.

# statt Parametern auch vielleicht erstmal mehrere <s>-Skripte?

# Fehler
# kein Satzende bei -que in allen Variationen, zum Beispiel q́; 
# <s>EA Virtutis est vis (Illustri ſsimi &amp; </s><s><lb/>Saptentiſſimi DD.)</s>

# das Skript sollte die Sprache berücksichtigen für den gesamten Text / jeweiligen Absatz

# wenn es noch keine <reg> im Text gibt, sollte q; wie in deniq; kein Satzende bewirken
