﻿#!/usr/bin/perl -w
use strict;
use warnings;
use utf8;
use open qw(:std :utf8);

use Getopt::Long;


# Filter_4_test_validity.pl
# 2010-08-15
# Wolfgang Schmidle

# This Filter is a wrapper for validating an XML document with Jing.
# Das Skript geht davon aus, dass es als Textfilter verwendet wird, denn sonst würde man Jing direkt aufrufen.

my $name = "Filter_4_test_validity";
my $textfilterParameters = "Filter_parameters/$name.txt";


# text input

my $file = shift @ARGV;

unless ($ENV{'BB_DOC_NAME'} =~ m!\.xml$!) { warn "Don't forget to save your document as .xml !\n(Filename $ENV{'BB_DOC_NAME'})\n\n"; }


# read the textfilter parameters

my $dir = "";
my $jing = "";
my $schema = "";

open (PARA, $textfilterParameters) or die "$name: can't find the parameter list!\n";
@ARGV = <PARA>;
close(PARA);
chomp @ARGV;

GetOptions("dir=s" => \$dir,
			"jing=s" => \$jing,
			"schema=s" => \$schema);

if ($dir) {
	unless ($dir =~ m!/$!) { $dir .= "/"; }
}

if ($jing eq "" || $schema eq "") { die "$name: found the parameter list, but can't read the parameters!\n"; }


# run jing

my $result = `java -jar $dir$jing -c $dir$schema "$file"`;

if ($result) {
	$result =~ s!/private[^:]+:!!g;
} else {
	$result = "The document is valid.\n";
}

die $result;

