﻿#!/usr/bin/perl -w
use strict;
use warnings;
use utf8;
use open qw(:std :utf8);
use integer;
use Unicode::Normalize;


# Filter_template.pl
# 2010-08-15
# Wolfgang Schmidle

# what does it do?
# input
# das Skript geht davon aus, dass die <pb> noch nicht verändert wurden,
# d.h. es reagiert nur auf <pb> der Form <pb ($digit+)>
# output

my $digit = "[〇一二三四五六七八九]";
my %arabic = ( 〇 => 0, 一 => 1, 二 => 2, 三 => 3, 四 => 4, 五 => 5, 六 => 6, 七 => 7, 八 => 8, 九 => 9 );  



# text input

my @text;
while(<>) { push @text, $_; }


# go through the text

foreach (@text) {

	if (m!<pb ($digit+)>!) { 
		my $onorm = $1;
		while ($onorm =~ m!($digit)!) {
			my $neu = $arabic{$1};
			$onorm =~ s!$digit!$neu!;
		}
		
		my $pseudo = $onorm;
		while (length $pseudo < 4) { $pseudo = "0" . $pseudo; }

		s!(<pb $digit+>)!$1\[o-norm=$onorm file=$pseudo\]!;
	}
}


# text output

print @text;


# TO DO:
# ...
