﻿#!/usr/bin/perl -w
use strict;
use warnings;
use utf8;
use open qw(:std :utf8);
use integer;
use Unicode::Normalize;


# Filter_Echo_TEI.pl
# 2010-05-23
# Wolfgang Schmidle

# transforms an Echo XML into a TEI document

# text input

my @text;
while(<>) { push @text, $_; }

my @newText;

# go through the text


print <<"PREAMBLE";
<?oxygen RNGSchema="http://www.tei-c.org/release/xml/tei/custom/schema/relaxng/tei_all.rng" type="xml"?> 
<TEI xmlns:xi="http://www.w3.org/2001/XInclude" xmlns:svg="http://www.w3.org/2000/svg" xmlns:math="http://www.w3.org/1998/Math/MathML" xmlns="http://www.tei-c.org/ns/1.0">
PREAMBLE



foreach (@text) {

	next if (m!<\?xml !);

	if (m!<echo !) {
		print <<"PREAMBLE";
<?oxygen RNGSchema="http://www.tei-c.org/release/xml/tei/custom/schema/relaxng/tei_all.rng" type="xml"?> 
<TEI xmlns:xi="http://www.w3.org/2001/XInclude" xmlns:svg="http://www.w3.org/2000/svg" xmlns:math="http://www.w3.org/1998/Math/MathML" xmlns="http://www.tei-c.org/ns/1.0">
PREAMBLE
		next;
	}

}


# text output

print @text;


# TO DO:
# ...
